#include "migrate.h"

extern sched_t sched_list;
extern fthread_t fthread_tab[];

extern fthread_t demux_fthread;
extern sched_t main_sched;


void setcontext(jmp_buf buf)
{
  longjmp(buf,1);
}

void swapcontext(jmp_buf buf1,jmp_buf buf2)
{
  if (setjmp(buf1) == 0)
    longjmp(buf2,1);
}

value swap_with(value static_n)
{
  fthread_t curr=sched_list->current;
  int nbr=Int_val(static_n);

  sched_list=fthread_tab[nbr]->sched;
  sched_list->current=fthread_tab[Int_val(static_n)];

  Before_switch(curr);
  swapcontext(curr->context,sched_list->current->context);
  After_switch(sched_list->current);
}


value swap_to_demux(value unit)
{
  fthread_t curr=sched_list->current;

  sched_list=main_sched;
  sched_list->current=demux_fthread;

  Before_switch(curr);
  swapcontext(curr->context,sched_list->current->context);
  After_switch(sched_list->current);
} 
