#include "migrate.h"

extern sched_t sched_list;

fthread_t demux_fthread;
sched_t main_sched;

int threads_alive=0;
int fthread_mode=0;

value get_max_comp(value unit)
{
  return Val_int(MAX_COMP);
}

value get_home(value unit)
{
  return Val_int(sched_list->current->home);
}

value max_nbr(value unit)
{
  return Val_int(MAX_STATIC_FTHREAD);
}

value do_nothing(value dumb)
{
  return 0;
}

value capture(value to_capture)
{
  return to_capture;
}

value decr_threads_alive(value unit)
{
  threads_alive--;
  return Val_unit;
}

value incr_threads_alive(value unit)
{
  threads_alive++;
  return Val_unit;
}

value get_fthread_mode(value unit)
{
  return Val_int(fthread_mode);
}


value register_demux(value fthread)
{
  demux_fthread=(fthread_t)fthread;
}


value register_main_sched(value sched)
{
  main_sched=(sched_t)sched;
}



